import sys
import re
import operator
from palabras import *
archivo_limpiar=sys.argv[1]
archivo_limpiar_d=archivo_limpiar.split('.')
archivo=open(archivo_limpiar,'r')
frases=list()
frases_limpias=list()
texto_momentaneo=list()
texto_final=list()
rank_uni=dict()
rank_bin=dict()
for linea in archivo:
	frases.append(linea.strip())
archivo.close()
lista_buscar=''
palabras=stop_words()
palabras_extras=0
for palabra in palabras:
	if '/' in palabra:
		palabra=palabra.split('/')
		lista_buscar+=palabra[0]+'|'+palabra[0]+palabra[1]+'|'
		palabra='/'.join(palabra)
		palabras_extras+=1
	else:
		lista_buscar+=palabra+'|'
	if palabras.index(palabra)+1==len(palabras)+palabras_extras:
		lista_buscar=lista_buscar.rstrip('|')

patron=re.compile('(?i)(\W|^)('+lista_buscar+')(\W|$)')
patron2=re.compile('(?i)(\W|^)([0-9]+\sde\s[a-z]+(\s(de(l){0,1}\s){0,1}[0-9]+){0,1}|[x|i]+|[0-9]+\,[0-9]+|[0-9]+\–[0-9]+|[0-9]+º{0,1})(\W|$)')

for frase in frases:
	reemplazo=patron2.sub(' ',frase)
	frase=reemplazo
	frase=frase.split()
	for palabra in frase:
		reemplazo1=patron.sub('',palabra)
		reemplazo1=reemplazo1.split()
		texto_final.append(''.join(reemplazo1))
		if '' in texto_final:
			texto_final.remove('')

archivo_final=open(archivo_limpiar_d[0]+' limpio.txt','w')
archivo_final.write(' '.join(texto_final))
archivo_final.close()

archivo_leer=open(archivo_limpiar_d[0]+' limpio.txt','r')
for linea in archivo_leer:
	frases_limpias.append(linea.strip())
archivo_leer.close()

patron3=re.compile('(?i)(\W|^)('+palabra+')(\W|$)')
indice=1
for frase in frases_limpias:
	frase=frase.lower()
	frase=frase.split()
	while indice<len(frase):
		if frase[indice-1]+' '+frase[indice] not in rank_bin:	
			rank_bin[frase[indice-1]+' '+frase[indice]]=1
		else:
			rank_bin[frase[indice-1]+' '+frase[indice]]+=1
		if frase[indice-1]+' '+frase[indice]=='mensaje presidencial':
			rank_bin[frase[indice-1]+' '+frase[indice]]=0
		indice+=1
	for palabra in frase:
		if palabra not in rank_uni:
			patron3=re.compile('(?i)(\W|^)('+palabra+')(\W|$)')
			cantidad=patron3.subn(' ',' '.join(frase))[1]
			frase=patron3.subn(' ',' '.join(frase))[0].split()
			rank_uni[palabra]=int(cantidad)

rank_uni_ord=sorted(rank_uni.items(), key=operator.itemgetter(1))
cantidad=1
escritura=list()
rank_bin_ord=sorted(rank_bin.items(), key=operator.itemgetter(1))
escritura_bin=list()
n_cantidad=1

archivo_rank=open('Ranking de terminos '+archivo_limpiar_d[0]+' limpio.txt','w')
archivo_rank.write('Top términos unitarios\n\n')
while len(escritura)<5:
	escritura.append(rank_uni_ord[len(rank_uni_ord)-cantidad])
	cantidad+=1
for unitario in escritura:
	archivo_rank.write(unitario[0]+' ('+str(unitario[1])+' veces.)\n')
archivo_rank.write('\nTop términos binarios\n\n')
while len(escritura_bin)<5:
	escritura_bin.append(rank_bin_ord[len(rank_bin_ord)-n_cantidad])
	n_cantidad+=1
for binario in escritura_bin:
	archivo_rank.write(binario[0]+' ('+str(binario[1])+' veces.)\n')
archivo_rank.close()



